.list
.psize 0
.att_syntax noprefix






with_vfork = 0

.ifc Linux,Linux
with_vfork = 1
.endif



_mbchar_= 1





_doloop_= 0

_doloop_= -1



_fornx_ = 0

_fornx_ = -1



_sighd_ = 0

_sighd_ = 1



BASE0 = 10





ORIGIN = 0x08048000





.include "scfctl.inc"
.include "scdefs.inc"

.set PAGE_SIZE,(1<<page_shift)
.set PAGE_MASK,-(PAGE_SIZE)


.set SIGHUP,1
.set SIGQUIT,3
.set SIGILL,4
.set SIGBUS,7
.set SIGFPE,8
.set SIGSEGV,11
.set SIGCHLD,17
.set SIGWINCH,28
.set SA_SIGINFO,4
.set SA_RESETHAND,0x80000000

stdin = 0
stdout = 1
stderr = 2

BSP = 8
HT = 9
DEL = 127
LF = 10


BL = 32
CPLO = 0x40
IMED = 0x80

MASKK = 0xfFfFfF1F
pchmask = 0xffa07e20
OCALL = 0xE8909090
                # should be padded with a 1 cycle 3-byte NOP.
                # - [hp] why not the proper jump label?! -
OCALL = 0xe800408d

CELSZ = 4 # Size of a cell
CELLMASK = -CELSZ # cell size alignment mask
NBPW = 32 # bits per word (cell)

VOCSS = 8 # Depth of vocabulary stack
                # for greater VOCSS adjust user vari access!
PADSZ = 512 # disp from "here" to "pad"
QRYSZ = PADSZ/2+4 # max chars by "query"
.set RS_SZ,65536
.set DS_SZ,65536
.set US_SZ,1024*4
.set NM_SZ,65536
.set CP_SZ,65536*2
.set TB_SZ,1024*4

.set NAMTP,0
.set RSTBT,(((NAMTP+NM_SZ)+PAGE_SIZE-1)&PAGE_MASK)
.set TIBB,(((RSTBT+RS_SZ+TB_SZ)+PAGE_SIZE-1)&PAGE_MASK)
.set UPTR,(((TIBB+US_SZ)+PAGE_SIZE-1)&PAGE_MASK)
.set DSTBT,(((UPTR+PAGE_SIZE)+PAGE_SIZE-1)&PAGE_MASK)

.set RPTR,RSTBT+6*CELSZ
.set SPTR,DSTBT+2*CELSZ

.set EM,(((DSTBT+DS_SZ+CP_SZ+PAGE_SIZE-1)+PAGE_SIZE-1)&PAGE_MASK)
_USER = 4*CELSZ
.macro resb n
.rept
        .byte 0
.endr
.endm
.macro spop num=1
.if \num > 2
.list
        movl (\num-1)*4(esp),ebx
        leal (\num)*4(esp),esp
.nolist
.else
    .if \num > 1
    .list
        popl ebx
    .nolist
    .endif
    .if \num > 0
    .list
        popl ebx
    .nolist
    .else
        leal 4(esp),esp
    .endif
.endif
.endm


.macro spush num=1
.rept \num
.list
        pushl ebx
.nolist
.endr
.endm
.macro rpop reg=ebx
.list
.ifnc \reg,0
        movl (ebp),\reg
.endif
        leal 4(ebp),ebp
.nolist
.endm


.macro rpush reg=ebx
.list
        leal -4(ebp),ebp
        movl \reg,(ebp)
.nolist
.endm


s_tor = 32
s_eax = 28
s_ecx = 24
s_edx = 20
s_ebx = 16
s_esp = 12
s_ebp = 8
s_esi = 4
.macro readad to,from
.list
    movl s_\from(esp),\to
.nolist
.endm


.macro writead to,from
.list
    movl \from,s_\to(esp)
.nolist
.endm
.macro __CODE lex=0,name,label,prev=0,mod=0
.list
        .data 1
        .align CELSZ,0x90
.ifeq \mod
\label:
.endif
.ifnes "\name",""
        .data 0
        .align CELSZ,0
        .long \label
    .ifndef n0
n0: .long 0
    .else
        .long 10001b
    .endif
10001:
n\label:
        .byte (10000f-1-.)|(\lex&-32)
        .ascii "\name"
10000:
_NAME = n\label
        .align CELSZ,0
_NTOP =.
        .data 1
.endif
.ifeq \mod
j\label:
.endif
.nolist
.endm


.macro __COLON lex=1,name,label,prev=0
.list
        __CODE \lex,"\name",\label,\prev,1
        lea 0(eax),eax
\label:
        call DOLST
j\label:
.nolist
.endm


.macro __USER lex=1,name,label,prev=0
.list
.if \lex
        __CODE \lex,"\name",\label,\prev,1
\label:
.equ u\label,_USER
        spush
        leal CELSZ(esi),esi
        leal u\label(edi),ebx
        jmpl *(esi)
.endif
        _USER = _USER+CELSZ
.nolist
.endm


.macro __VARI lex=1,name,label,prev=0
.list
        __CODE \lex,"\name",\label,\prev,1
\label:
        spush
        leal CELSZ(esi),esi
        movl $v\label,ebx
        jmpl *(esi)
        .align CELSZ,0x90
v\label:
.nolist
.endm



        .text 0

        .align CELSZ,0
        .globl _start


SHT: .asciz "/bin/sh"
        .align CELSZ,0
RG1:.asciz "sh"
        .align CELSZ,0
RG2:.asciz "-c"
        .align CELSZ,0
ARGS: .long RG1,RG2,CMD+4,0
        .align CELSZ,0

.include "scdata.inc"

ttyt: .asciz "/dev/tty"
self0t: .asciz "/proc/self/fd/0"

        .align CELSZ,0
ttyst:
        .long 0x2102
        .long 0x0005
        .long 0x04bf
        .long 0x8A3B
        .byte 0
l1:
        .byte 0x03
        .byte 0x1C
        .byte 0x7F
        .byte 0x15
        .byte 0x4
        .byte 0x0
        .byte 0x1
        .byte 0x0
        .byte 0x11
        .byte 0x13
        .byte 0x1A
        .byte 0x0
        .byte 0x12
        .byte 0x0F
        .byte 0x17
        .byte 0x16
        .byte 0x0
l2:
        .rept NCCS-17

        .byte 0
        .endr

        .align CELSZ,0

.if _sighd_



.set NSIG,64
.set SIGRTMIN,32



.set fpesig, 0b00000000000000000000000100000000
.set winchsig, 0b00010000000000000000000000000000
.set segvsig, 0b00000000000000000000100010000000
.set ilegsig, 0b00000000000000000000000000010000
.set chldsig, 0b00000000000000100000000000000000
.set quitsig, 0b00000000000000000000000000001000







.set fpesig, 0
.set winchsig, 0


.set quitsig, 0
.set chldsg, 0
sa_x:
        .long b
        .long SA_SIGINFO
        .long 0
        .long 0
        .long 0
sa_m:
sa_i:
        .long r
        .long SA_SIGINFO
        .long 0
        .long 0
        .long 0
.if winchsig
sa_winch:
        .long winch
        .long SA_SIGINFO
        .long 0
        .long 0
        .long 0
.endif
.if fpesig
sa_fpe:
        .long fpe
        .long SA_SIGINFO
        .long 0
        .long 0
        .long 0
.endif
.ifeq segvsig|ilegsig
.else


sa_segv:
        .long segv
        .long SA_SIGINFO
        .long 0
        .long 0
        .long 0

.endif
.if quitsig
sa_quit:
        .long quits
        .long SA_SIGINFO
        .long 0
        .long 0
        .long 0
.endif
.if chldsig
sa_chld:
        .long c
        .long SA_SIGINFO
        .long 0
        .long 0
        .long 0
.endif



.set sgnsys, 0b01010101000100100010000100101000
.set sgnsys,sgnsys&~(fpesig|winchsig|segvsig|ilegsig|quitsig|chldsig)

.set sgmask, 0b01000001011000011000101011010110
.set sgmask,sgmask|fpesig|winchsig|segvsig|ilegsig|quitsig|chldsig
        .align CELSZ,0x90
isegf:

        pushal
        movl $0,edi
        movl edi,edx
        leal 31(edi),ebx
        leal NSIG/8(edi),esi
1:
        movl $sgnsys,eax
        btl ebx,eax
        jc 2f
        movl $sa_x,ecx
        movl $sgmask,eax
        btl ebx,eax
        jc 3f
        addl $(sa_i-sa_x),ecx
3:
        sys_ rt_sigaction

2:
        addl $SIGRTMIN,ebx
        movl $sa_m,ecx
        sys_ rt_sigaction
        subl $SIGRTMIN+1,ebx
        jns 1b

.if fpesig
        movl $SIGFPE,ebx
        movl $sa_fpe,ecx
        sys_ rt_sigaction
.endif
.if winchsig
        movl $SIGWINCH,ebx
        movl $sa_winch,ecx
        sys_ rt_sigaction
.endif
.if ilegsig
        movl $SIGBUS,ebx
        movl $sa_segv,ecx
        sys_ rt_sigaction
        movl $SIGILL,ebx
        movl $sa_segv,ecx
        sys_ rt_sigaction
.endif
.if segvsig
        mov $SIGSEGV,ebx
        movl $sa_segv,ecx
        sys_ rt_sigaction
.endif
.if quitsig
        movl $SIGQUIT,ebx
        movl $sa_quit,ecx
        sys_ rt_sigaction
.endif
.if chldsig
        movl $SIGCHLD,ebx
        movl $sa_chld,ecx
        sys_ rt_sigaction
.endif
        popal
9:
        ret





sigr:
        cmpl $1,uIERR(edi)
        pushl edx
        pushl ecx
        pushl eax
        leal 20(esp),edx
        movl (edx),ecx
        movl 8(edx),edx
        movl 19*4(edx),edx
        jg 1f
        call sigp
        negl ecx
        pushal
        pushl edx
        movl ecx,eax
        movl $(('$'*256+':')*256+'G')*256+'S',edx
        call e4pn.s
        movl (esp),eax
        movl $(':'*256+'t')*256+'a',edx
        call e4pn.l
        popl edx
        leal -ORIGIN(edx),eax
        movl $((':'*256+'h')*256+'t')*256+'4',edx
        call e4pn.s
        popal
1:



2:
        popl eax
        popl ecx
        popl edx
        ret
sigp:
        pushal
        sys_ getpid
        movl $(('$'*256+':')*256+'P')*256+LF,edx
        call e4pn.s
        popal
        ret

e4pn.l:
        xorl ebx,ebx
        jmp 1f
e4pn.s:
        movl eax,ebx
        sarl $24,ebx
        movb $8,bl
        jns 1f
        negl eax
1:
        testl edx,edx
        jz 0f
        pushal
        movl $4,edx
        leal s_edx(esp),ecx
        movl $stderr,ebx
        sys_ write
        popal
0:
e4pn.n:
        leal -12(esp),esp
        movl $8,ecx
        movb $' ',(esp)
2:
        movb $15,dl
        andb al,dl
        cmpb $10,dl
        jc 3f
        addb $7,dl
3:
        addb $'0',dl
        movb dl,(esp,ecx)
        decb bl
        js 4f
        testl eax,eax
        jz 5f
4:
        shrl $4,eax
        decl ecx
        jg 2b
5:
        movl $9,edx
        leal (esp,ecx),ecx
        testb bl,bl
        js 6f
        testl ebx,ebx
        movzbl bl,ebx
        jns 7f
        decl ecx
        incl edx
        movb $'-',(ecx)
7:
        incl ebx
        subl ebx,edx
6:
        movb $' ',(ecx,edx)
        incl edx
        movl $stderr,ebx
        sys_ write
        leal 12(esp),esp
        ret
hupjobs:
        pushal
        sys_ getgid
        movl eax,ebx
        movl $SIGHUP,ecx
        negl ebx
        sys_ kill
hupjobs.k:
        popal
        ret

.if fpesig
fpe:


        pushal
        leal s_tor+4(esp),eax
        movl 8(eax),eax
        leal 19*4(eax),edx
        movl $fpebx,ecx
        movl (edx),eax
        movl (eax),eax
        cmpb $0xf3,ah
        jz 1f
        movl $fpebxi,ecx
        cmpb $0xfb,ah
        jz 1f
        movl $2f,ecx
1:
        movl ecx,(edx)
        popal
2:
        ret
.endif
.if segvsig
segv:
        incl (sgf)
        cmpl $1,(sgf)
        jg b
        call sigr
        pushl eax
        movl 12(esp),eax
        movl $cold,19*4(eax)
        popl eax
        ret
.endif
.if quitsig

quits:
        pushl eax
        movl 12(esp),eax
        movl $warm,19*4(eax)
        popl eax
        ret
.endif


b:
        call sigr
        mov (esp),ebx
        testl ebx,ebx
        jns 1f
        negl ebx
1:
        jmp xBBI

r:
        call sigr
        nop
c:
        ret
.if fpesig
fpebx:
        cmpl $1,ebx
        jz rpureg
        jc rzreg
        pushl eax
        movl edx,eax
        xorl edx,edx
        divl ebx
        popl eax
        divl ebx
        ret
fpebxi:
        cmpl $-1,ebx
        jz rmureg
        jl 1f
        cmpl $1,ebx
        jz rpureg
        jl rzreg
1:
        pushl eax
        movl edx,eax
        xorl edx,edx
        idivl ebx
fpebxi.l:
        movl eax,edx
        popl eax
        idivl ebx
        ret
ruureg:
        incl edx
        jz rpureg
        decl edx
        jz rpureg.r
        negl edx
        mov edx,eax
rmureg:
        negl eax
rpureg:
        movl $0,edx
rpureg.r:
        ret
rzreg:
        orl edx,eax
        jz rzreg.e
        sarl $31,edx
        notl edx
        leal 0x80000001(,edx,2),eax
        mov eax,edx
        ret
rzreg.e:
        incl eax
        ret
.endif
.if winchsig

winch: movl eax,esp
        andl $-4096,esp
        popl ebx
        popl ecx
        popl edx
        popl esi
        popl edi
        movl esi,uWCH(edi)
        popl ebp
        xchg (esp),eax
        movl esp,(esp)
.endif
.else
.equ sigp,return
.endif
return:
        ret





        .align CELSZ,0x90
_start:
        popl ecx
        leal 4(esp,ecx,4),eax

        movl esp,(argv4e)
        movl eax,(env4e)
        xorl ebx,ebx
        sys_ brk
        movl eax,(obssi)
        leal EM(eax),ebx
        andl $PAGE_MASK,ebx
        sys_ brk
        movl eax,(ontop)
        movl eax,(brkaddr)
        movl $0xfeededda,ebx
        leal -SPTR(eax),esp
        leal -RPTR(eax),ebp
        leal -TIBB(eax),ecx
        leal -UPTR(eax),edi
        movl esp,(os0)
        movl ebp,(or0)
        movl ecx,(otib)
        movl edi,(ou0)
        movl edi,(up2)
        spush
.if _sighd_
        call isegf
.endif
        movl $COLD1,esi
        jmpl *(esi)



        .data 0
        .align CELSZ,0



porg: .long cold
        .long warm
obssi: .long 0
UZERO:
ou0: .long 0,0,0,0
argc4e: .long 0
argv4e: .long 0
env4e: .long 0
brkaddr:.long 0
os0: .long 0
or0: .long 0
otqkey: .long QRX
otemit: .long TXSTO
otexp: .long ACCEP
ottap: .long KTAP
otecho: .long TXSTO
otprompt:.long DOTOK
obase: .long BASE0
otmp: .long 0
ospan: .long 0
otoin: .long 0
ontib: .long 0
otib: .long 0
oblk: .long 0
ocsp: .long 0
oteval: .long INTER
otnum: .long NUMBQ
ohld: .long 0
ohnd: .long 0
ocntx: .long 0
.rept VOCSS
        .long 0
.endr
ocurnt: .long 0
ovocl: .long FORTHv
ocp: .long CTOP
ontop: .long 0
olast: .long LASTN
okbd: .long -1
ostdin: .long stdin
ostdou: .long stdout
ostder: .long stderr
oioer: .long 0
odocol: .long DOCOL
odexit: .long DEXIT
ostate: .long 0
ULAST:

up2: .long 0
sgf: .long 0

stattr:
.rept termios_size
        .long -1
.endr

tattr:
.rept termios_size
        .long -1
.endr

        .data 1
warm:
        movl (up2),edi
        movl uRZERO(edi),ebp
.if 0 ; -?-


        cmpl esp,esi
        jc 1f

        leal 11*CELSZ(esp),esp
1:
        cmpl uSZERO(edi),esp
        jc 2f
.endif
        movl uSZERO(edi),esp
2:
        movl $jABORT,esi
        jmpl *(esi)
cold:
        movl $COLD1,esi
        jmpl *(esi)



        __CODE,"tic",TI
        spush
        leal CELSZ(esi),esi
        rdtsc
        movl eax,ebx
        jmpl *(esi)



        __CODE,"bp",BP
        int $3
        leal CELSZ(esi),esi
        jmpl *(esi)
        __CODE,"[s]",BSYSB
        pushl ebx
        leal CELSZ(esi),esi
        movl $syscalref,ebx
        jmpl *(esi)




        __CODE,"(s)",PSYSP
        movl ebx,eax
        testl ebx,ebx
        leal CELSZ(esi),esi
        pushl edi
        pushl esi
        pushl $0
.set p_US,8
        mov $syscalref-2,edx
        mov -10(edx),ecx
        js 1f
        jz 3f
        leal 4(ebx),ebx
5:
        movl -4(ebx),eax
1:
        decl ecx
        js 3f
        movl edx,edi
        movzbl (edx),edx
        leal 4(edi,edx),edi
        movl edi,edx
        scasl
        jnz 4f
        movzbl al,eax
        subl $3,eax
        movl ebx,esi
        js 5b
        jz 2f
        xchg eax,ecx
        repz cmpsb
        mov eax,ecx
        jnz 5b
2:
        movzbl -2(edx),ecx
        movl ecx,(esp)
3:
        popl ebx
        popl esi
        popl edi
        jmpl *(esi)
4:
        testl eax,eax
        jns 1b
        cmpl eax,ebx
        jnz 1b
        pushal
        movl (+p_US)(esp),edi
        leal 1(edx),ecx
        movzbl (edx),edx
        movl uSTDOUT(edi),ebx
        sys_ write
        leal uTEMP(edi),ecx
        movb $BL,(ecx)
        movl $1,edx
        sys_ write
        popal
        jmp 1b
        __CODE,"ssc",SC
        movl ebx,eax
        leal CELSZ(esi),esi
        movl (esp),ebx
        pushl ebp
        pushl edi
        pushl esi
        movl ebx,edi
        movl (ebx),ebx
        movl 4(edi),ecx
        movl 8(edi),edx
        movl 12(edi),esi
        movl 20(edi),ebp
        movl 16(edi),edi
        sys_
        popl esi
        popl edi
        popl ebp
        movl eax,ebx
        jmpl *(esi)







        __CODE,"bye",BYE
        xorl ebx,ebx



        __CODE,"bbi",BBI
xBBI:
        call sttys
        sys_ exit



        __CODE,"w4f",W4F
        leal CELSZ(esi),esi
        call wf
        spop
        jmpl *(esi)
        .align CELSZ,0x90
wf:
        cmpl $32,ebx
        pushl esi
        pushl edi
        jnc 1f
        movl ebx,ecx
        movl esp,esi
        movzbl bh,ebx
        btsl ecx,ebx
        pushl ebx
        movl esp,ecx
        movl $0x7fffffff,ebx
        pushl ebx
        pushl ebx
        movl esp,edi
        pushl esi
        xorl edx,edx
        movl ecx,esi
        leal 32(edx),ebx
        sys_ _newselect
        movl (esp),esp
1:
        popl edi
        popl esi
        ret




        __CODE,"?rx",QRX
        pushl ebx
        leal CELSZ(esi),esi
        movl uSTDIN(edi),ebx
        pushl $0
        movl esp,ecx
        movl $1,edx
        sys_ read
        negl eax
        js 1f
        addl $4,esp
        xorl eax,eax
1:
        movl eax,ebx
        jmpl *(esi)




        __CODE 3,"key",KEY
        pushl ebx
        leal CELSZ(esi),esi
        movl uSTDIN(edi),ebx
        call wf



        lea uIERR(edi),ecx
        movl uSTDIN(edi),ebx
        movl $1,edx
        sys_ read
        movzbl (ecx),ebx
        mov eax,(ecx)
        negl eax
        js 2f
        xorl ebx,ebx
2:
        jmpl *(esi)




        __CODE,"tx!", TXSTO
.if _mbchar_
        movl ebx,edx
        bsrl ebx,edx
        leal 7(edx),edx
        shrl $3,edx
        jnz 1f
        incl edx
1:
.else
        movzbl %bl,%ebx
        movl $1,%edx
.endif
        leal CELSZ(esi),esi
        pushl ebx
        movl uSTDOUT(edi),ebx
        leal (esp),ecx
        sys_ write
        popl ecx
        popl ebx
        jmpl *(esi)




        __CODE,"!io",STOIO
        cmpl $0,uKBD(edi)
        leal CELSZ(esi),esi
        jns IOMODEn
        call vtsto
        call kbopen
        call vtini
        call inonbl
        jmpl *(esi)
        .align CELSZ,0x90
kbopen:
        pushal
        xorl edx,edx
        movl uKBD(edi),ebx
        cmpl edx,ebx
        jns vtini_n
        movl $ttyt,ebx
        movl $O_RDWR,ecx
        sys_ open
        movl eax,uKBD(edi)
        mov eax,ebx
        jmp vtini_n
        .align CELSZ,0x90

vtini: pushal
vtini_n:
        movl $TCGETS,ecx
        movl $tattr,edx
        sys_ ioctl
        andl $(~(ICANON|ECHO)),termios_c_lflag(edx)
        orl $ONLCR,termios_c_oflag(edx)
        andl $(~(INPCK|ISTRIP|IXON)),termios_c_iflag(edx)
        movb $1,termios_c_cc+VTIME(edx)
        movb $1,termios_c_cc+VMIN(edx)
        movl $TCSETS,ecx
        sys_ ioctl
        popal
        ret

inonbl:
        pushal
        movl uSTDIN(edi),ebx
        movl $(O_RDWR|O_NONBLOCK),edx
        movl $F_SETFL,ecx
        sys_ fcntl
        popal
        ret

vtsto:
        movl uSTDIN(edi),ebx
        movl $TCGETS,ecx
        movl $stattr,edx
        sys_ ioctl
        ret



        __CODE,"sttys",STTYS
        leal CELSZ(esi),esi
        call sttys
        jmpl *(esi)
sttys:
        cmpl $0,uKBD(edi)
        js 1f
        pushal
.ifdef stattr
        movl $stattr,edx
.else
        movl $ttyst,edx
.endif
        movl uKBD(edi),ebx
        movl $TCSETS,ecx
        sys_ ioctl
        movl uSTDIN(edi),ebx
        sys_ ioctl
        popal
1:
        ret





        __CODE,"iomode",IOMODE
        leal CELSZ(esi),esi
IOMODEn:
        pushal
        movl uSTDIN(edi),ebx
        movl $F_SETFL,ecx
        movl $(O_RDONLY|O_NONBLOCK),edx
        sys_ fcntl
        movl uSTDOUT(edi),ebx
        movl $(O_WRONLY|O_SYNC),edx
        sys_ fcntl
        popal
        jmpl *(esi)
        __USER,"wsz",WCH





        __USER,"arg",CARGC



        __USER,"env",CENVC



        __USER,"bss",CBRK
        __CODE CPLO,"dovar",DOVAR
        spush
        leal CELSZ(esi),ebx
        rpop %esi
        jmpl *(esi)



        __CODE,"uv",UP
        spush
        leal CELSZ(esi),esi
        movl edi,ebx
        jmpl *(esi)



        __CODE,"+rg",PORIGIN,UP
        leal CELSZ(esi),esi
        addl $porg,ebx
        jmpl *(esi)



        __CODE CPLO,"douser",DOUSE,PORIGIN
        spush
        leal CELSZ(esi),esi
        movl (esi),ebx
        addl edi,ebx
        rpop esi
        jmpl *(esi)



        __USER,"sp0",SZERO



        __USER,"rp0",RZERO



        __USER,"'?key",TQKEY



        __USER,"'emit",TEMIT



        __USER,"'expect",TEXPE



        __USER,"'tap",TTAP



        __USER,"'echo",TECHO



        __USER,"'prompt",TPROM



        __USER,"base", BASE



        __USER,,TEMP



        __USER,"span",SPAN



        __USER,">in",TOIN



        __USER,"blk",BLK




        __USER,"#tib",NTIB
        __USER,,TIBP



        __USER,"csp",CSP



        __USER,"'eval",TEVAL



        __USER,"'number",TNUMB



        __USER,"hld", HLD



        __USER,"handler",HANDL



        __USER,"context",CNTXT
        _USER = _USER+VOCSS*CELSZ



        __USER,"current",CRRNT
        __USER,,VOCL



        __USER,"cp",CP



        __USER,"np",NP



        __USER,"last",LAST




        __USER,"kbd",KBD



        __USER,"stdin",STDIN



        __USER,"stdout",STDOUT



        __USER,"stderr",STDERR



        __USER,"err",IERR



        __USER,"(:)",BDOCOL



        __USER,"(\073)",BDEXIT



        __USER,"state",STATE







        __CODE CPLO,"dolit",DOLIT
        pushl ebx
        mov 4(esi),ebx
        addl $8,esi
        jmpl *(esi)



        __CODE CPLO,"docol",DOLST
        jmp *uBDOCOL(edi)

        __CODE,,DOCOL
        leal CELSZ(esi),esi
        subl $CELSZ,%ebp
        movl %esi,(%ebp)
        popl %esi
        jmpl *(esi)



        __CODE,"exit",EXIT
        jmp *uBDEXIT(edi)

        __CODE,,DEXIT
        leal CELSZ(esi),esi
        movl (%ebp),%esi
        addl $CELSZ,%ebp
        jmpl *(esi)



        __CODE CPLO,"(n)",DONXT
        subl $1,(%ebp)
        leal CELSZ(esi),esi
        jc 1f
        movl (%esi),%esi
        jmpl *(esi)
1: addl $CELSZ,%ebp
        addl $CELSZ,%esi
        jmpl *(esi)



        __CODE CPLO,"0branch",ZBRA
        testl ebx,ebx
        popl ebx
        jz BRAN
ZBRAn:
        addl $2*CELSZ,%esi
        jmpl *(esi)



        __CODE CPLO,"-b",NZBRA
        testl ebx,ebx
        popl ebx
        jz ZBRAn




        __CODE CPLO, "branch",BRAN
        movl 4(%esi),%esi
        jmpl *(esi)



        __CODE CPLO,"=b",EQBRA
        movl ebx,ecx
        popl eax
        popl ebx
        cmpl eax,ecx
        jnz ZBRAn
        movl 4(%esi),%esi
        jmpl *(esi)



        __CODE,"execute",EXECU
        movl ebx,eax
        popl ebx
        jmp *eax



        __CODE,"!",STORE
        popl (ebx)
        leal CELSZ(esi),esi
        popl ebx
        jmpl *(esi)



        __CODE,"@",AT
        leal CELSZ(esi),esi
        movl (ebx),ebx
        jmpl *(esi)



        __CODE,"c!",CSTOR
        popl eax
        leal CELSZ(esi),esi
        movb al,(ebx)
        popl ebx
        jmpl *(esi)



        __CODE,"c@",CAT
        leal CELSZ(esi),esi
        movzbl (ebx),ebx
        jmpl *(esi)



        __CODE,"rp@",RPAT
        pushl ebx
        leal CELSZ(esi),esi
        movl ebp,ebx
        jmpl *(esi)



        __CODE CPLO,"rp!",RPSTO
        movl ebx,ebp
        leal CELSZ(esi),esi
        popl ebx
        jmpl *(esi)



        __CODE CPLO,"r>",RFROM
        pushl ebx
        leal CELSZ(esi),esi
        movl (ebp),ebx
        addl $CELSZ,ebp
        jmpl *(esi)
.if _doloop_



__CODE 2, "ni",NI
        leal CELSZ(esi),esi
        mov (ebp,ebx,(2*CELSZ)),ebx
        jmpl *(esi)





        __CODE,"i",I
        __CODE,"r@",RAT
.else
        __CODE,"r@",RAT
.endif
        pushl ebx
        leal CELSZ(esi),esi
        movl (ebp),ebx
        jmpl *(esi)



        __CODE CPLO,">r",TOR
        subl $CELSZ,ebp
        leal CELSZ(esi),esi
        movl ebx,(ebp)
        popl ebx
        jmpl *(esi)



        __CODE CPLO,">rr",TORR
        subl $CELSZ,ebp
        leal CELSZ(esi),esi
        movl ebx,(ebp)
        jmpl *(esi)



        __CODE CPLO,"r>drop",RDROP
        leal CELSZ(esi),esi
        addl $CELSZ,ebp
        jmpl *(esi)



        __CODE,"sp@",SPAT
        pushl ebx
        leal CELSZ(esi),esi
        movl esp,ebx
        jmpl *(esi)



        __CODE 3,"sp!",SPSTO
        movl ebx,esp
        leal CELSZ(esi),esi
        popl ebx
        jmpl *(esi)



        __CODE,"sp>",SPGT
        movl uSZERO(edi),esp
        leal CELSZ(esi),esi
        popl ebx
        jmpl *(esi)



        __CODE,"ndrop",NDROP
        leal (esp,ebx,4),esp



        __CODE,"drop",DROP
        leal CELSZ(esi),esi
        popl ebx
        jmpl *(esi)



        __CODE,"2drop",DDROP
        leal CELSZ(esi),esi
        spop 2
        jmpl *(esi)



        __CODE,"dup",DUP
        leal CELSZ(esi),esi
        pushl ebx
        jmpl *(esi)



        __CODE,"2dup",DDUP
        movl (esp),eax
        leal CELSZ(esi),esi
        pushl ebx
        pushl eax
        jmpl *(esi)



        __CODE,"swap",SWAP
        movl (esp),eax
        leal CELSZ(esi),esi
        movl ebx,(esp)
        movl eax,ebx
        jmpl *(esi)



        __CODE,"over",OVER
        pushl ebx
        leal CELSZ(esi),esi
        movl CELSZ(%esp),ebx
        jmpl *(esi)



        __CODE,"o-",OVERM
        leal CELSZ(esi),esi
        subl (esp),ebx
        jmpl *(esi)



        __CODE,"0<",ZLESS
        leal CELSZ(esi),esi
        sarl $31,ebx
        jmpl *(esi)



        __CODE,"and",ANDD
        popl eax
        leal CELSZ(esi),esi
        andl eax,ebx
        jmpl *(esi)



        __CODE,"or",ORR
        popl eax
        leal CELSZ(esi),esi
        orl eax,ebx
        jmpl *(esi)



        __CODE,"xor",XORR
        popl eax
        leal CELSZ(esi),esi
        xorl eax,ebx
        jmpl *(esi)



        __CODE,"um+",UPLUS
        addl ebx,(((1)-1)*CELSZ)(esp)
        sbbl ebx,ebx
        leal CELSZ(esi),esi
        negl ebx
        jmpl *(esi)





        __CODE,"pick",PICK
        testl ebx,ebx
        leal CELSZ(esi),esi
        js 1f
        movl (esp,ebx,4),ebx
        jmpl *(esi)
1: negl ebx
        movl (((1)-1)*CELSZ)(esp),ecx
        js 3f
        movl ecx,4(esp,ebx,4)
2: spop
3: spop
        jmpl *(esi)




        __CODE,"aroll",AROLL
        movl ebx,eax
        spop
        jmp ROLLn



        __CODE,"-rot",MROT
        spush
        movl $-2,ebx
        jmp jROLL



        __CODE,"rot",ROT
        spush
        movl $2,ebx




        __CODE,"roll",ROLL
        movl esp,eax
ROLLn: testl ebx,ebx
        movl ebx,ecx
        jz 2f
        pushl edi
        pushl esi
        js 1f
        lea (eax,ecx,4),edi
        std
        lea -4(edi),esi
        movl (edi),edx
        rep movsl
        cld
        movl edx,(eax)
3:
        popl esi
        popl edi
2:
        leal CELSZ(esi),esi
        popl ebx
        jmpl *(esi)
1:
        negl ecx
        movl eax,edi
        movl (eax),edx
        leal 4(edi),esi
        rep movsl
        mov edx,(edi)
        jmp 3b



        __CODE,"cmove",CMOVE
        mov ebx,ecx
        testl ebx,ebx
        leal CELSZ(esi),esi
        movl edi,ebx
        movl esi,edx
        popl edi
        popl esi
        jng 1f
        cmpl edi,esi
        jc 2f
        jz 1f
        rep movsb
1:
        movl ebx,edi
        movl edx,esi
        popl ebx
        jmpl *(esi)
2:
        lea -1(edi,ecx),edi
        lea -1(esi,ecx),esi
        std
        rep movsb
        cld
        jmp 1b



        __CODE,"erase",ERASE
        spush
        xor ebx,ebx




        __CODE,"fill",FILL
        movl edi,edx
        leal CELSZ(esi),esi
        popl ecx
        popl edi
        testl ecx,ecx
        mov ebx,eax
        jng 1f
        rep stosb
1:
        popl ebx
        movl edx,edi
        jmpl *(esi)



        __CODE,"2+",TWOP
        push $2



__CODE,"+",PLUS
        popl eax
        leal CELSZ(esi),esi
        addl eax,ebx
        jmpl *(esi)



__CODE,"0=",ZEQ
        push $0




__CODE,"=",EQUAL
        popl eax
        leal CELSZ(esi),esi
        cmpl eax,ebx
        movl $0,ebx
        jz strue
        jmpl *(esi)



__CODE,"<",LESS
        popl %eax
        leal CELSZ(esi),esi
        cmpl ebx,%eax
        movl $0,ebx
        jge sfalse
strue:
        decl ebx
sfalse:
        jmpl *(esi)




__CODE,"1+",ONEP
        leal CELSZ(esi),esi
        incl ebx
        jmpl *(esi)




__CODE,"1-",ONEM
        leal CELSZ(esi),esi
        decl ebx
        jmpl *(esi)




__CODE,"4+",CELLP
        leal CELSZ(esi),esi
        leal CELSZ(ebx),ebx
        jmpl *(esi)




__CODE,"4-",CELLM
        leal CELSZ(esi),esi
        leal -CELSZ(ebx),ebx
        jmpl *(esi)



__CODE,"shift",SHIFT
        movl ebx,ecx
        testl ebx,ebx
        leal CELSZ(esi),esi
        popl ebx
        js .r
        shll cl,ebx
        jmpl *(esi)
.r:
        negl ecx
        shrl cl,ebx
        jmpl *(esi)



__CODE,"2*",TWOMUL
        leal CELSZ(esi),esi
        sall $1,ebx
        jmpl *(esi)




__CODE,"4*",CELLS
        leal CELSZ(esi),esi
        sall $2,ebx
        jmpl *(esi)



__CODE,"2/",TWOBY
        leal CELSZ(esi),esi
        sarl $1,ebx
        jmpl *(esi)




__CODE,"4/",CELSZBY
        leal CELSZ(esi),esi
        sarl $2,ebx
        jmpl *(esi)





__CODE,"flg",FLG
        spush
        leal CELSZ(esi),esi
        pushfl
        pop ebx
        jmpl *(esi)





__CODE,"zcount",ZCOUNT
        movl ebx,ecx
        leal CELSZ(esi),esi
        pushl ebx
        notl ecx
zcount.n:
        cmpb $1,(ebx)
        incl ebx
        jnc zcount.n
        addl ecx,ebx
        jmpl *(esi)



__CODE,"st@",STATEF
        spush
        leal CELSZ(esi),esi
        movl uSTATE(edi),ebx
        jmpl *(esi)







__CODE CPLO,"dovoc",DOVOC
        leal 2*CELSZ(esi),ecx
        rpop esi
        movl ecx,uCNTXT(edi)
        jmpl *(esi)



__COLON,"forth",FORTH
        .long DOVOC
        .long 0
        .long LASTN
FORTHv: .long 0



__CODE,"?dup",QDUP
        test ebx,ebx
        leal CELSZ(esi),esi
        jz 1f
        spush
1:
        jmpl *(esi)



__CODE,"not",INVER
        leal CELSZ(esi),esi
        notl ebx
        jmpl *(esi)



__CODE,"negate",NEGAT
        leal CELSZ(esi),esi
        neg ebx
        jmpl *(esi)



__CODE,"dnegate",DNEGA
        negl (esp)
        adcl $0,ebx
        leal CELSZ(esi),esi
        neg ebx
        jmpl *(esi)



__CODE,"2-",TWOM
        leal CELSZ(esi),esi
        subl $2,ebx
        jmpl *(esi)



__CODE,"-",SUBB
        movl ebx,eax
        leal CELSZ(esi),esi
        popl ebx
        subl eax,ebx
        jmpl *(esi)



__CODE,"abs",ABSS
        testl ebx,ebx
        leal CELSZ(esi),esi
        jns 1f
        negl ebx
1:
        jmpl *(esi)



__CODE,"u<",ULESS
        movl ebx,eax
        popl ecx
        leal CELSZ(esi),esi
        xorl ecx,eax
        js 1f
        subl ebx,ecx
        movl ecx,ebx
1:
        sarl $31,ebx
        jmpl *(esi)



__CODE,"max",MAX
        popl eax
        leal CELSZ(esi),esi
        cmpl eax,ebx
        jng 2f
        jmpl *(esi)



__CODE,"min",MIN
        popl eax
        leal CELSZ(esi),esi
        cmpl eax,ebx
        jl 1f
2:
        movl eax,ebx
1:
        jmpl *(esi)



__CODE,"within",WITHI
        popl eax
        popl ecx
        subl eax,ebx
        subl eax,ecx
        leal CELSZ(esi),esi
        cmpl ebx,ecx
        sbbl ebx,ebx
        jmpl *(esi)
__CODE,"sm/rem",SMBYR
        popl edx
        popl eax
        leal CELSZ(esi),esi
        test ebx,ebx
        movl ebx,ecx
        jz RDZ1
        cmpl $-1,ebx
        jz RDM
        idiv ebx
1:
        movl eax,ebx
        pushl edx
        jmpl *(esi)
RDM:
        negl eax
        xorl edx,edx
        jmp 1b






__CODE,"um/mod",UMMOD
        popl edx
        popl eax
        leal CELSZ(esi),esi
        testl ebx,ebx
        jz RDZ1
        cmp edx,ebx
        jc 1f
        div ebx
        pushl edx
        movl eax,ebx
        jmpl *(esi)
1:
        pushl eax
        mov edx,ebx
        jmpl *(esi)





        __CODE,"fm/mod",FMMOD
        popl edx
        popl eax
        leal CELSZ(esi),esi
        testl ebx,ebx
        movl ebx,ecx
        jz RDZ1
        jns 1f
        negl ebx
        negl eax
        adcl $0,edx
        negl edx
1:
        testl edx,edx
        jns 2f
        addl ebx,edx
2:
        divl ebx
        testl ecx,ecx
        jg 3f
        jnz 4f
        testl edx,edx
        jz 4f
        negl eax
4:
        negl edx
3:
        movl eax,ebx
        pushl edx
        jmpl *(esi)
RDZ1:
        call RDZ
        jmp 3b
RDZ:
        orl edx,eax
        lea 1(eax),eax
        jz RDZ3
        leal 0x80000001(,edx,2),eax
RDZ2:
        negl eax
RDZ3:
        xorl edx,edx
        ret




        __CODE,"/mod",SLMOD
        movl (esp),edx
        call dv
        movl edx,(esp)
        movl eax,ebx
        jmpl *(esi)



        __CODE,"mod",MODD
        popl edx
        call dv
        movl edx,ebx
        jmpl *(esi)



        __CODE,"/",SLASH
        popl edx
        call dv
        movl eax,ebx
        jmpl *(esi)
dv:
        movl edx,eax
        sarl $31,edx
        testl ebx,ebx
        leal CELSZ(esi),esi
        jz RDZ
        cmpl $-1,ebx
        jz RDZ2
        idiv ebx
        ret







        __CODE,"um*",UMSTA
        movl (esp),eax
        leal CELSZ(esi),esi
        mull ebx
        movl eax,(esp)
        movl edx,ebx
        jmpl *(esi)



        __CODE,"*",STAR
        popl eax
        leal CELSZ(esi),esi
        imull ebx
        movl eax,ebx
        jmpl *(esi)



        __CODE,"m*",MSTAR
        movl ebx,eax
        leal CELSZ(esi),esi
        imull (esp)
        movl eax,(esp)
        movl edx,ebx
        jmpl *(esi)



        __COLON,"*/mod",SSMOD
        .long TOR,MSTAR,RFROM,SMBYR,EXIT



        __COLON,"*/",STASL
        .long SSMOD,SWAP,DROP,EXIT







        __CODE,"aligned",ALGND
        addl $CELSZ-1,ebx
        leal CELSZ(esi),esi
        andl $CELLMASK,ebx
        jmpl *(esi)



        __CODE,"bl",BLANK
        spush
        leal CELSZ(esi),esi
        movl $BL,ebx
        jmpl *(esi)



        __CODE,"key>char",K2C
        movzbl bl,ecx
        leal CELSZ(esi),esi
        cmpb $HT,bl
        movl $pchmask,edx
        movl $-1,ebx
        jz 3f
1:
        cmpb dl,cl
        jb 2f
        cmp dh,cl
        jbe 3f
        shrl $16,edx
        jnz 1b
2:
        incl ebx
3:
        pushl ecx
        jmpl *(esi)




        __CODE,">char",TCHAR
    .if _mbchar_
        movl ebx,eax
        leal CELSZ(esi),esi
        bsrl ebx,eax
        leal 7(eax),eax
        shrl $3,eax
        jnz 1f
        incl eax
1:
        leal (,eax,8),ecx
    .else
        leal CELSZ(esi),esi
    .endif
2:
        movl $pchmask,edx
3:
        cmpb dl,bl
        jb 4f
        cmpb dh,bl
        jbe 5f
        shrl $16,edx
        jnz 3b
4:
        movb $'.',bl
5:
    .if _mbchar_
        rorl $8,ebx
        decl eax
        jg 2b
        roll cl,ebx
    .endif
        jmpl *(esi)



        __CODE,"depth",DEPTH
        spush
        leal CELSZ(esi),esi
        movl uSZERO(edi),ebx
        subl esp,ebx
        sarl $2,ebx
        jmpl *(esi)







        __CODE,"perform",ATEXE
        movl (ebx),eax
        testl eax,eax
        jz PSTORx
        popl ebx
        jmp *eax



        __CODE,"+!",PSTOR
        popl eax
        addl eax,(ebx)
PSTORx:
        leal CELSZ(esi),esi
        popl ebx
        jmpl *(esi)



        __CODE,"d!",DSTOR
        popl ecx
        popl eax
DSTOR2:
        movl ebx,edx
        leal CELSZ(esi),esi
        popl ebx
        movl eax,(edx)
        movl ecx,4(edx)
        jmpl *(esi)



        __CODE,"d@",DFETCH
        movl (ebx),eax
        movl 4(ebx),ebx
DFETCH2:
        leal CELSZ(esi),esi
        pushl eax
        jmpl *(esi)




        __CODE,"2!",STOR2
        popl eax
        popl ecx
        jmp DSTOR2




        __CODE,"2@",FETCH2
        movl 4(ebx),eax
        movl (ebx),ebx
        jmp DFETCH2






        __CODE,"count",COUNT
        movzbl (ebx),eax
        incl ebx
        leal CELSZ(esi),esi
        pushl ebx
        movl eax,ebx
        jmpl *(esi)



        __CODE,"here",HERE
        spush
        leal CELSZ(esi),esi
        movl uCP(edi),ebx
        jmpl *(esi)



        __CODE,"pad",PAD
        spush
        leal CELSZ(esi),esi
        movl uCP(edi),ebx
        addl $PADSZ,ebx
        jmpl *(esi)



        __CODE,"tib",TIB
        spush
        leal CELSZ(esi),esi
        movl uTIBP(edi),ebx
        jmpl *(esi)



        __CODE,"-trailing",DTRAI
        mov (esp),edx
        movzwl bx,ecx
        leal CELSZ(esi),esi
        lea (ecx,edx),ebx
1:
        decl ebx
        decl ecx
        js 2f
        cmpb $' ',(ebx)
        jz 1b
        incl ebx
2:
        subl edx,ebx
        jmpl *(esi)




        __CODE,,PACKSZ
        movl (esp),ecx
        movl $0,(ebx,ecx)

        __CODE,"packs",PACKS
        lea CELSZ-1(ebx),ecx
        movl 4(esp),eax
        movl (esp),ebx
        andl $CELLMASK,ecx
        movl ebx,edx
        negl edx
        sarl $31,edx
        andl edx,ebx
        movl eax,(esp)
        movl ecx,4(esp)
        leal (ebx,ecx),eax
        andl $CELLMASK,eax
        movl $0,(eax)
        mov bl,(ecx)
        incl ecx
        pushl ecx
        jmp CMOVE







        __CODE,"bs@",BASEF
        spush
        leal CELSZ(esi),esi
        movl uBASE(edi),ebx
        jmpl *(esi)



        __CODE,"digit",DIGIT
        movzbl bl,ebx
        jmp EXTRCn



        __CODE,"(#)",EXTRC
        movl (esp),eax
        xorl edx,edx
        divl ebx
        movl eax,(esp)
        movzbl dl,ebx
EXTRCn:
        leal CELSZ(esi),esi
        cmp $10,bl
        jc 2f
        addb $7,bl
2:
        addb $'0',bl
        jmpl *(esi)



        __CODE,"<#",LTSHARP
        movl uCP(edi),eax
        addl $PADSZ,eax
        leal CELSZ(esi),esi
        movl eax,uHLD(edi)
        jmpl *(esi)



        __CODE,"sign",SIGN
        testl ebx,ebx
        movl $'-',ebx
        jns DROP




        __CODE,"hold",HOLD
        movl uHLD(edi),ecx
        leal CELSZ(esi),esi
        decl ecx
        movl ecx,uHLD(edi)
        movb bl,(ecx)
        popl ebx
        jmpl *(esi)



        __COLON,"#",SHARP
        .long BASEF,EXTRC,HOLD,EXIT



        __COLON,"#s",SHARPS
1: .long SHARP,DUP
        .long NZBRA,1b
        .long EXIT



        __COLON,"#>",SHARPGT
        .long DROP,HLD,AT
        .long PAD,OVERM,EXIT



        __COLON,"<#s>",SDIGS
        .long TORR,ABSS
        .long LTSHARP,SHARPS,RFROM
        .long SIGN,SHARPGT,EXIT



        __CODE,"hex",HEX
        leal CELSZ(esi),esi
        movl $16,uBASE(edi)
        jmpl *(esi)



        __CODE,"decimal",DECIM
        leal CELSZ(esi),esi
        movl $10,uBASE(edi)
        jmpl *(esi)







        __CODE,"digit?",DIGTQ
        leal CELSZ(esi),esi
        movl (esp),ecx
        movzbl cl,eax
        mov al,ah
        cmpb $'a',al
        jc 2f
        xor $32,al
2:
        subb $'0',al
        jc 1f
        cmpb $10,al
        jc 3f
        cmpb $17,al
        jc 1f
        subb $7,al
3:
        cmp bl,al
        jnc 1f
        movzbl al,ecx
        decb bh
1:
        movl ecx,(esp)
        movsbl bh,ebx
        jmpl *(esi)

        __CODE,,QN1
        pushl ebx
        pushl $0
        leal CELSZ(esi),esi
        incl ebx
        pushl ebx
        movzbl -1(ebx),ecx
        pushl ecx
        movb (ebx),cl
        movl $16,edx
        cmpb $'$',cl
        movl uBASE(edi),eax
        jz 1f
        cmpb $'#',cl
        jz 2f
        cmpb $'@',cl
        jz 3f
        cmpb $'&',cl
        jz 3f
        cmpb $'#',cl
        jz 2f
        cmpb $'%',cl
        jnz 4f
        subl $6,edx
3:
        subl $2,edx
2:
        subl $6,edx
1:
        movl edx,eax
        incl 4(esp)
        decl (esp)
4:
        movl eax,edx
        xorl ecx,ecx
        cmpb $'-',(ebx)
        jnz 5f
        incl 4(esp)
        decl (esp)
        decl ecx
5:
        movl (esp),ebx
        decl (esp)
        pushl ebx
        pushl ecx
        movl uBASE(edi),ebx
        movl edx,uBASE(edi)
        jmpl *(esi)





        __COLON,"number?",NUMBQ
        .long QN1,TOR,TOR
        .long ZBRA,6f
        .long TOR
2: .long TORR,CAT,BASEF,DIGTQ
        .long ZBRA,4f
        .long SWAP,BASEF,STAR,PLUS,RFROM
        .long ONEP
        .long DONXT,2b
        .long RAT,SWAP,DROP
        .long ZBRA,3f
        .long NEGAT
3: .long SWAP
        .long BRAN,5f
4: .long RDROP,RDROP,DDROP,ZERO
5: .long DUP
6: .long RDROP,DROP
        .long RFROM,BASE,STORE,EXIT
        __COLON IMED,"sys",SYS
        .long BLW,PSYSP,LITERAL,MCPL,SC,EXIT



        __CODE,"?key",QKEY
        jmp *uTQKEY(edi)



        __CODE,"cr",CR4
        spush
        movl $LF,ebx



        __CODE,"emit",EMIT
        jmp *uTEMIT(edi)



        __CODE,"space",SPACE
        spush
        xorl ebx,ebx
        incl ebx



        __CODE,"spaces",SPACES
        xorl edx,edx
        testl ebx,ebx
        leal CELSZ(esi),esi
        jng 1f
        lea ' '(edx),eax
        pushal
        movl ebx,esi
        incl edx
        movl uSTDOUT(edi),ebx
        lea s_eax(esp),ecx
2:
        sys_ write
        decl esi
        jg 2b
        popal
1:
        spop
        jmpl *(esi)



        __CODE,"pt",PRINT
        movzbl (ebx),eax
        incl ebx
        spush
        movl eax,ebx



        __CODE,"type",TYPES
        testl ebx,ebx
        movzwl bx,edx
        leal CELSZ(esi),esi
        popl ecx
        jng 1f
        testl ecx,ecx
        pushal
        jz 2f
        movl uSTDOUT(edi),ebx
        sys_ write
2:
        popal
1:
        popl ebx
        jmpl *(esi)



        __COLON,".r",DOTR
        .long TOR,SDIGS
DOTR1: .long RFROM
        .long OVERM
        .long SPACES,TYPES,EXIT



        __COLON,"u.r",UDOTR
        .long TOR,LTSHARP,SHARPS,SHARPGT
        .long BRAN,DOTR1



        __COLON,"u.",UDOT
        .long LTSHARP,SHARPS,SHARPGT
        .long TYPES,SPACE,EXIT



        __CODE,"?",QUEST
        movl (ebx),ebx




        __COLON,".",DOT
        .long SDIGS,TYPES,SPACE,EXIT
  skip:
        test ecx,ecx
        jng 1f
        pushl edi
        movl ebx,edi
        cmpl $(BL<<8|BL),eax
        jz 2f
        repz scasb
        incl ecx
3:
        decl ecx
4:
        leal 1(ecx),ebx
        leal -1(edi),eax
        popl edi
        ret
1:
        movl ebx,eax
        mov ecx,ebx
        ret
2:
        scasb
        jc 3b
        decl ecx
        jnz 2b
        jmp 4b




  scan:
        testl ecx,ecx
        jng 1b
        pushl edi
        movl ebx,edi
        cmp $(BL<<8|BL),eax
        jz 5f
        repnz scasb
        jz 4b
        jmp 6f
5:
        scasb
        jnc 3b #
        decl ecx
        jnz 5b
6:
        incl edi
        jmp 3b






        __CODE,"skip",SKIP
        movl ebx,eax
        popl ecx
        movl (esp),ebx
        leal CELSZ(esi),esi
        call skip
        mov eax,(esp)
        jmpl *(esi)
        __CODE,"scan",SCAN
        movl ebx,eax
        popl ecx
        movl (esp),ebx
        leal CELSZ(esi),esi
        call scan
        movl eax,(esp)
        jmpl *(esi)

        __CODE,,PARSE41
        spush
        movl $')',ebx




        __CODE,"parse",PARSE
        movzbl bl,eax
        movl uNTIB(edi),ecx
        movl uTOIN(edi),edx
        movl uTIBP(edi),ebx
        leal CELSZ(esi),esi
        addl edx,ebx
        subl edx,ecx


        cmpb $BL,al
        pushl ebx
        jnz 1f
        movb al,ah
        call skip
        movl ebx,ecx
        movl eax,ebx
        movl $(BL<<8|BL),eax
1:
        pushl ebx
        call scan
        popl edx
        testl ebx,ebx
        popl ecx
        movl eax,ebx
        jz 2f
        incl ebx
2:
        subl edx,eax
        subl ecx,ebx
        addl ebx,uTOIN(edi)
        pushl edx
        movl eax,ebx
        jmpl *(esi)



        __COLON IMED,".(",DOTPR
        .long PARSE41,TYPES,EXIT



        __COLON IMED,"(",PAREN
        .long PARSE41,DDROP,EXIT



        __CODE IMED,"\\",BKSLA
        movl uNTIB(edi),eax
        leal CELSZ(esi),esi
        movl eax,uTOIN(edi)
        jmpl *(esi)



        __COLON IMED,"char",CHAR
        .long BLANK,PARSE,DROP,CAT,LITERAL,EXIT



        __COLON,"token",TOKEN
        .long BLANK,PARSE
        .long DOLIT,31,MIN
        .long NP,AT,OVERM,CELLM
        .long PACKS
        .long EXIT

BLW:
        pushl ebx
        movl $' ',ebx



        __COLON,"word",WORDD
        .long PARSE,HERE,PACKSZ,EXIT







        __CODE,"name>",NAMETO
        leal CELSZ(esi),esi
        movl -8(ebx),ebx
        jmpl *(esi)




        __CODE,"same?",SAMEQ
        testl ebx,ebx
        leal CELSZ(esi),esi
        jz 1f
        pushl edi
        pushl esi
        movl ebx,ecx
        movl 8(esp),esi
        movl 12(esp),edi
        xorl ebx,ebx
        repz cmpsl
        jz 2f
        incl ebx
        movl -4(esi),eax
        cmpl -4(edi),eax
        jc 2f
        negl ebx
2:
        popl esi
        popl edi
1:
        jmpl *(esi)



        __COLON,"(find)",FIND
        .long SWAP,DUP,CAT
        .long CELSZBY,TEMP,STORE
        .long DUP,AT,TOR,CELLP,SWAP

FIND1: .long AT,DUP
        .long ZBRA,FIND6
        .long DUP,AT
        .long DOLIT,MASKK,ANDD,RAT
        .long XORR
        .long NZBRA,FIND01
        .long CELLP,TEMP,AT,SAMEQ
        .long ZBRA,FIND5
        .long CELLM
FIND01: .long CELLM
        .long BRAN,FIND1

FIND6: .long RDROP
        .long SWAP,CELLM,SWAP,EXIT

FIND5: .long RDROP,SWAP,DROP
        .long CELLM
        .long DUP,NAMETO,SWAP,EXIT






        __COLON,"name?",NAMEQ
        .long CNTXT,DUP,FETCH2
        .long EQBRA,1f
        .long CELLM
1: .long TOR
2: .long RFROM,CELLP,TORR
        .long AT,DUP
        .long ZBRA,3f
        .long FIND,QDUP
        .long ZBRA,2b
3: .long RDROP,EXIT




        __COLON,"find",FFIND
        .long NAMEQ
        .LONG 1f
1:
        testl ebx,ebx
        jz 2f
        testl $IMED,(ebx)
        movl $1,ebx
        jnz 2f
        negl ebx
2:
        jmp EXIT







        __CODE,,BKSP
        cmpl 4(esp),ebx
        jbe NOOP
        decl ebx
        pushl ebx
        movl $((BSP<<16)|(' '<<8)|BSP),ebx
        jmp EMIT




        __CODE,,TAP
        popl ecx
        leal CELSZ(esi),esi
        movb bl,(ecx)
        leal 1(ecx),ebx
        jmpl *(esi)



        __CODE,,KTAP
        cmpb $LF,bl
        jnz 2f
        movl (esp),ecx
        movl ecx,CELSZ(esp)
        jmp EMIT

        __CODE,,FTAP
2: cmp $DEL,bl
        jz 1f
        mov $BL,bl
        jmp TAP
1:
        spop
        jmp BKSP



        __COLON,"accept",ACCEP
        .long OVER,PLUS,OVER
1: .long DDUP
        .long EQBRA,4f
        .long KEY,K2C
        .long ZBRA,2f
        .long FILEQ,NZBRA,5f
        .long DUP,EMIT
5: .long TAP
        .long BRAN,1b
2: .long TTAP,ATEXE
3: .long BRAN,1b
4: .long DROP,OVERM,EXIT



        __COLON,"expect",EXPEC
        .long TEXPE,ATEXE,SPAN,STORE,DROP,EXIT




.if 1
        __CODE,"query",QUERY
        spush
        pushl uTIBP(edi)
        pushl $QRYSZ
        movl uTEXPE(edi),ebx
        call DOLST
        .long EXECU
        .long 1f
1:
        movl ebx,uNTIB(edi)
        movl $0,uTOIN(edi)
        spop 2
        jmp EXIT
.else
        __COLON,"query",QUERY
        .long TIB,DOLIT,QRYSZ,TEXPE,ATEXE
        .long NTIB,STORE
        .long DROP,ZERO,TOIN,STORE,EXIT
.endif







        __COLON,"catch",CATCH
        .long SPAT,TOR,HANDL,AT,TOR
        .long RPAT,HANDL,STORE,EXECU
        .long RFROM,HANDL,STORE
        .long RDROP,ZERO,EXIT




        __CODE,"throw",THROW
        testl ebx,ebx
        movl uHANDL(edi),eax
        jz .r
        test eax,eax
        jz 1f
        movl (eax),ecx
        movl 4(eax),esp
        movl 8(eax),esi
        leal 12(eax),ebp
        movl ecx,uHANDL(edi)
1:
        popl ebx
        jmpl *(esi)



        __CODE,"abort",ABORT
        movl $vNULLS,ebx
        jmp THROW


        __COLON CPLO,,ABORQ
        .long ZBRA,ABOR1
        .long DOSTR,THROW
ABOR1: .long DOSTR,DROP,EXIT
        __COLON,"(itp)",INTER
        .long NAMEQ,QDUP
        .long ZBRA,INTE1
        .long AT,DOLIT,CPLO,ANDD
        .long ABORQ
        .byte 1f-.-1
        .ascii " compile only"
1:
        .align CELSZ,0
        .long EXECU,EXIT
INTE1: .long TNUMB,ATEXE
        .long ZBRA,INTE2
        .long EXIT
INTE2: .long THROW



        __CODE IMED,"[",LBRAC
        leal CELSZ(esi),esi
        movl $INTER,uTEVAL(edi)
        andl $0,uSTATE(edi)
        jmpl *(esi)



        __COLON,".ok",DOTOK
        .long CR4,POKP,ATEXE,EXIT



        __VARI,"(ok)",POKP
        .long DOTS,BOKB



        __CODE,"[ok]",BOKB
        spush
        cmpl $INTER,uTEVAL(edi)
        movl $(('>'<<8|'k')<<8)|'o',ebx
        jz 1f
        shrl $16,ebx
1:
        jmp EMIT



        __COLON,"?stack",QSTAC
        .long DEPTH,ZLESS
        .long ABORQ
        .byte 1f-.-1
        .ascii " underflow"
1:
        .align CELSZ,0
        .long EXIT



        __COLON,"eval",EVAL
        .long BRAN,EVAL1
EVAL2: .long TEVAL,ATEXE,QSTAC
EVAL1: .long TOKEN,DUP,CAT
        .long NZBRA,EVAL2
        .long DROP,TPROM,ATEXE,EXIT







        __CODE,"preset",PRESET
        movl (brkaddr),eax
        movl uSZERO(edi),esp
        leal -TIBB(eax),ecx
        leal CELSZ(esi),esi
        movl ecx,uTIBP(edi)
        popl ebx
        jmpl *(esi)



        __CODE,"file",FILE
        movl $NOOP,uTPROM(edi)
        movl $DROP,uTECHO(edi)
        movl $FTAP,uTTAP(edi)
FIS:
        leal CELSZ(esi),esi
        movl $0,(sgf)
        movl $ACCEP,uTEXPE(edi)
        jmpl *(esi)



        __CODE,"terminal",HAND
        movl $DOTOK,uTPROM(edi)
        movl $EMIT,uTECHO(edi)
        movl $KTAP,uTTAP(edi)
        jmp FIS



        __CODE,"console",CONSOLE
        movl vISLO+4,ecx
        movl vISLO,edx
        movl ecx,uTEMIT(edi)
        movl edx,uTQKEY(edi)
        jmp HAND



        __CODE,"fi?",FILEQ
        pushl ebx
        leal CELSZ(esi),esi
        movl $0,ebx
        pushal
        movl $1024,edx
        movl esp,ebp
        leal -1024(esp),ecx
        movl $self0t,ebx
        movl ecx,esp
        sys_ readlink
        testl eax,eax
        movl $ttyt,esi
        movl esp,edi
        jng 2f
        cmpsl
        jnz 3f
        cmpsl
        jz 2f

.equ ptyt,((('y<<8)|'t)<<8|'p)<<8|'/
.equ ptst,((('s<<8)|'t)<<8|'p)<<8|'/
        cmpl $ptyt,-4(edi)
        jz 2f
        cmpl $ptst,-4(edi)
        jz 2f
3:
        decl s_ebx(ebp)
2:
        movl ebp,esp
        popal
1:
        jmpl *(esi)




        __VARI,"i/o",ISLO
        .long QRX,TXSTO



        __COLON,"quit",QUIT
        .long RZERO,AT,RPSTO
QUIT1: .long LBRAC
QUIT2: .long QUERY
        .long DOLIT,EVAL,CATCH,QDUP
        .long ZBRA,QUIT2

        .long CONSOLE
        .long NULLS,OVER
        .long EQBRA,QUIT3
        .long SPACE,COUNT
QUIT.c: .long UTYPEFF
        .long DOTQP
        .byte 1f-.-1
        .ascii " ? "
1:
        .align CELSZ,0
QUIT3:



QUIT4: .long PRESET
        .long BRAN,QUIT1
        __COLON,"'",TICK
        .long TOKEN,NAMEQ
        .long ZBRA,TICK1
        .long EXIT
TICK1: .long THROW



        __CODE,"allot",ALLOT
        leal CELSZ(esi),esi
        addl ebx,uCP(edi)
        jmpl *(esi)



        __CODE,"0,",ZCOMMA
        spush
        movl $0,ebx




        __CODE,",",COMMA
        movl uCP(edi),eax
        leal CELSZ(esi),esi
        movl ebx,(eax)
        addl $CELSZ,eax
        popl ebx
        movl eax,uCP(edi)
        jmpl *(esi)



        __COLON IMED,"[compile]",BCOMP
        .long TICK,COMMA,EXIT



        __CODE CPLO,"compile",CMPL
        movl 4(esi),eax
        movl uCP(edi),ecx
        addl $8,esi
        addl $CELSZ,uCP(edi)
        movl eax,(ecx)
        jmpl *(esi)



        __CODE CPLO,"-compile",MCPL
        cmpl $SCOMP,uTEVAL(edi)
        jz CMPL
NOOP:
        leal CELSZ(esi),esi
        jmpl *(esi)



        __COLON IMED,"literal",LITERAL
        .long STATEF,ZBRA,LITERx
        .long CMPL,DOLIT,COMMA
LITERx: .long EXIT
.if _doloop_

        __CODE,"(d)",PDOP
        leal -8(ebp),ebp
        leal CELSZ(esi),esi
        movl ebx,(ebp)
        popl eax
        popl ebx
        movl eax,4(ebp)
        jmpl *(esi)

        __CODE,"(-)",PMLEAVEP
        testl ebx,ebx
        leal CELSZ(esi),esi
        spop
        jz 1f
        movl (ebp),eax
        incl eax
        movl eax,4(ebp)
1:
        jmpl *(esi)

        __CODE,"(+)",PPLOOPP
        movl ebx,ecx
        testl ebx,ebx
        leal (ecx,ebx),ecx
        popl ebx
        jz PLOOPPn
        movl 4(ebp),eax
        movl (ebp),ecx
        leal 0x80000000(eax),eax
        leal 0x80000000(ecx),ecx
        js 2f
        cmpl eax,ecx
        jnc 3f
1:
        movl 4(esi),esi
        jmpl *(esi)
2:
        cmpl eax,ecx
        jnc 1b
PPLOOPPr:
3:
        addl $2*CELSZ,esi
        addl $2*CELSZ,ebp
        jmpl *(esi)

        __CODE,"(l)",PLOOPP
        mov (ebp),ecx
PLOOPPn:
        incl ecx
        cmpl 4(ebp),ecx
        movl ecx,(ebp)
        jz PPLOOPPr
        movl 4(esi),esi
        jmpl *(esi)
        __COLON IMED+2,"do",DO
        .long CMPL,PDOP,HERE,EXIT



        __COLON IMED,"-leave",MLEAVE
        .long CMPL,PMLEAVEP,EXIT




        __COLON IMED+4,"+loop",PLOOP
        .long CMPL,PPLOOPP,COMMA,EXIT



        __COLON IMED+4,"loop",LOOP
        .long CMPL,PLOOPP,COMMA,EXIT
.endif

.if ((_fornx_)|(~_doloop_))
        __COLON IMED,"for",FOR
        .long CMPL,TOR,HERE,EXIT



        __COLON IMED,"aft",AFT
        .long DROP,AHEAD,BEGIN,SWAP,EXIT



        __COLON IMED,"next",NEXT
        .long CMPL,DONXT,COMMA,EXIT
.endif






        __CODE IMED,"begin",BEGIN
        jmp HERE



        __COLON IMED,"until",UNTIL
        .long CMPL,ZBRA,COMMA,EXIT



        __COLON IMED,"again",AGAIN
        .long CMPL,BRAN,COMMA,EXIT



        __COLON IMED,"if",IFF
        .long CMPL,ZBRA,HERE
        .long ZCOMMA,EXIT



        __COLON IMED,"ahead",AHEAD
        .long CMPL,BRAN,HERE
        .long ZCOMMA,EXIT



        __COLON IMED,"repeat",REPEA
        .long AGAIN,HERE,SWAP,STORE,EXIT




        __CODE IMED,"endif",ENDIF
        __CODE IMED,"then",THENN
        movl uCP(edi),eax
        leal CELSZ(esi),esi
        movl eax,(ebx)
        spop
        jmpl *(esi)



        __COLON IMED,"else",ELSEE
        .long AHEAD,SWAP,THENN,EXIT



        __COLON IMED,"while",WHILE
        .long IFF,SWAP,EXIT



        __COLON IMED,"abort\042",ABRTQ
        .long CMPL,ABORQ,STRCQ,EXIT







        __CODE IMED,"c\042",STRQ
        cmpl $SCOMP,uTEVAL(edi)
        jnz jQTE
        call DOLST
        .long CMPL,STRQP,STRCQ,EXIT



        __COLON IMED,".\042",DOTQ
        .long STATEF,ZBRA,IDOTQ
        .long CMPL,DOTQP,STRCQ,EXIT
IDOTQ:
        .long QTE,PRINT,EXIT



        __CODE IMED,"(\042)",QTE
        spush
        mov $'"',ebx
        jmp WORDD



        __COLON CPLO,"(c\042)",STRQP
        .long DOSTR,EXIT



        __COLON CPLO,"(.\042)",DOTQP
        .long DOSTR,PRINT,EXIT

        __CODE,,DOSTR
        spush
        mov (ebp),ebx
        leal CELSZ(esi),esi
        movzbl (ebx),edx
        leal 4(ebx,edx),eax
        andl $CELLMASK,eax
        movl eax,(ebp)
        jmpl *(esi)

        __COLON CPLO,,STRCQ
        .long QTE,STGS
STGS:
        movzbl (ebx),eax
        leal 1(ebx,eax),eax
        spop
        movl $0,(eax)
        addl $CELSZ-1,eax
        andl $CELLMASK,eax
        movl eax,uCP(edi)
        jmp EXIT



        __CODE,"nul",ZERO
        spush
        leal CELSZ(esi),esi
        xorl ebx,ebx
        jmpl *(esi)



        __VARI,"\042nul",NULLS
        .long 0







        __COLON,"?unique",UNIQU
        .long DUP,NAMEQ
        .long ZBRA,UNIQ1
        .long DOTQP
        .byte 1f-.-1
        .ascii " redef "
1:
        .align CELSZ,0
        .long OVER,PRINT
UNIQ1: .long DROP,EXIT



        __COLON,"head",SNAME
        .long DUP,CAT
        .long ZBRA,PNAM1
        .long UNIQU
        .long HEADS
HEADS:
        movl ebx,uLAST(edi)
        subl $CELSZ,ebx
        movl uCRRNT(edi),edx
        movl (edx),edx
        movl edx,(ebx)
        subl $CELSZ,ebx
        movl ebx,uNP(edi)
        movl uCP(edi),eax
        addl $CELSZ-1,eax
        andl $CELLMASK,eax
        addl $3,eax
        movl eax,(ebx)
        spop
        jmp EXIT

PNAM1: .long STRQP
        .byte 1f-.-1
        .ascii " name"
1:
        .align CELSZ,0
        .long THROW







        __COLON 8,"(cpl)",SCOMP
.if 1
        .long FFIND,QDUP
        .long ZBRA,2f
        .long ONEP
.else
        .long NAMEQ,QDUP
        .long ZBRA,2f
        .long AT,DOLIT,IMED,ANDD
.endif
        .long ZBRA,1f
        .long EXECU,EXIT
1: .long COMMA,EXIT
2: .long TNUMB,ATEXE
        .long ZBRA,3f
        .long LITERAL,EXIT
3: .long THROW



        __CODE,"overt",OVERT
        movl uLAST(edi),ecx
        movl uCRRNT(edi),eax
        leal CELSZ(esi),esi
        movl ecx,(eax)
        jmpl *(esi)



        __COLON IMED+CPLO,"\073",SEMIS
        .long CMPL,EXIT,LBRAC,OVERT,EXIT



        __CODE,"]",RBRAC
        leal CELSZ(esi),esi
        or $1,uSTATE(edi)
        movl $SCOMP,uTEVAL(edi)
        jmpl *(esi)



        __CODE,"call,",CALLC
        movl uCP(edi),edx
        lea 8(edx),ecx
        leal CELSZ(esi),esi
        movl ecx,uCP(edi)
        movl $OCALL,(edx)
        subl ecx,ebx
        movl ebx,4(edx)
        popl ebx
        jmpl *(esi)



        __COLON,":",COLON
        .long TOKEN,SNAME,DOLIT,DOLST
        .long CALLC,RBRAC,EXIT



        __CODE,"immediate",IMMED
        movl uLAST(edi),eax
        leal CELSZ(esi),esi
        orb $IMED,(eax)
        jmpl *(esi)







        __COLON,"user",USER
        .long CREAT,CUSER
CUSER:
        movl uCP(edi),eax
        addl $CELSZ,uCP(edi)
        movl $DOUSE,-CELSZ(eax)
        movl ebx,(eax)
        popl ebx
        jmp EXIT



        __COLON,"create",CREAT
        .long TOKEN,SNAME,OVERT
        .long DOLIT,DOLST,CALLC
        .long DOLIT,DOVAR,COMMA,EXIT



        __COLON,"variable",VARIA
        .long CREAT
        .long ZCOMMA,EXIT

SDOES:
        movl ebx,eax
        leal CELSZ(esi),ebx
        movl (esp),esi
        movl eax,(esp)
        jmpl *(esi)



        __COLON CPLO,"dds",DDOES
        .long RFROM,LAST,AT,NAMETO,ONEP,ALGND,CELLP,STORE,EXIT




        __COLON IMED,"does>",DOES
        .long DOLIT,DDOES,COMMA
        .long DOLIT,SDOES,CALLC,EXIT



        __COLON,"constant",CONS
        .long CREAT,CCONS
CCONS:
        movl uCP(edi),eax
        movl $DOCONS,-CELSZ(eax)
        movl ebx,(eax)
        popl ebx
        jmp EXIT
DOCONS:
        pushl ebx
        leal CELSZ(esi),esi
        movl (%esi),ebx
        movl (%ebp),%esi
        addl $CELSZ,%ebp
        jmpl *(esi)







        .align 4,0x90
        nop;nop
UTYPE31:
        andl $31,ebx
UTYPEFF:
        movzbl bl,ebx
        __COLON,"typep",UTYPE
        .long TOR
        .long BRAN,UTYP2
UTYP1:
        .long COUNT,TCHAR,EMIT
UTYP2: .long DONXT,UTYP1
        .long DROP,EXIT


        __COLON,,DUMPP
        .long OVER,DOLIT,4,UDOTR
        .long SPACE,TOR
        .long BRAN,PDUM2
PDUM1: .long DUP,CAT,DOLIT,3,UDOTR
        .long ONEP
PDUM2: .long DONXT,PDUM1
        .long EXIT



        __COLON,"dump",DUMP
        .long BASEF,TOR,HEX
        .long DOLIT,16,SLASH
        .long TOR
DUMP1: .long CR4,DOLIT,16,DDUP
        .long DUMPP
        .long MROT
        .long SPACE,SPACE,UTYPE
        .long DONXT,DUMP1
        .long BRAN,DUMP3
DUMP3: .long DROP,RFROM,BASE,STORE
        .long EXIT



        __COLON,".s",DOTS
        .long DEPTH
        .long TOR
        .long BRAN,DOTS2
DOTS1: .long RAT,PICK,DOTSD
DOTS2: .long DONXT,DOTS1
        .long DOTQP
        .byte 1f-.-1
        .ascii "<sp "
1:
        .align CELSZ,0
        .long EXIT

        __CODE,,DOTSD
        cmpl $10,uBASE(edi)
        jz DOT
        jmp UDOT



        __COLON,"?csp",QCSP
        .long SPAT,CSP,AT
        .long ABORQ
        .byte 1f-.-1
        .ascii "stacks"
1:
        .align CELSZ,0
        .long EXIT



        __CODE,"!csp",STCSP
        leal CELSZ(esi),esi
        movl esp,uCSP(edi)
        jmpl *(esi)



        __CODE,">name",TNAME
        leal uCNTXT(edi),ecx
        leal CELSZ(esi),esi
1: movl (ecx),edx
        testl edx,edx
        lea 4(ecx),ecx
        jz 6f
2:
        movl (edx),edx
        testl edx,edx
        jz 1b
        cmpl $_start,edx
        jc 6f
        cmpl uCBRK(edi),edx
        jc 5f
        cmpl uNP(edi),edx
        jc 6f
        cmpl otib,edx
        jnc 6f
5: cmpl -8(edx),ebx
        jz 3f
        subl $4,edx
        jmp 2b
6: xorl edx,edx
3: movl edx,ebx
        jmpl *(esi)



        __COLON,".id",DOTID
        .long QDUP
        .long ZBRA,DOTI1
        .long COUNT
        .long UTYPE31,EXIT
DOTI1: .long DOTQP
        .byte 1f-.-1
        .ascii " {noName}"
1:
        .align CELSZ,0
        .long EXIT



        __COLON,"see",SEE
        .long TICK
        .long ALGND
        .long DUP,CELLP
SEEDOT: .long DOT,DOLIT,10,SPACES
SEELOOP:
        .long CELLP
        .long DUP,AT
        .long ZBRA,DONESEE

        .long DUP,AT
        .long TNAME
        .long DUP,ZBRA,CHECKEND
        .long DOTID,SPACE,SPACE
        .long BRAN,SEELOOP
CHECKEND:
        .long DROP,DUP,AT
        .long DOLIT,OCALL
        .long EQUAL,INVER
        .long ZBRA,DONESEE
        .long SPACE
        .long DUP,AT,DOT
        .long CR4,DUP
        .long BRAN,SEEDOT
DONESEE:.long DROP,EXIT



        __COLON 5,"words",WORDS
        .long CR4,CNTXT,AT
WORS1: .long AT,QDUP
        .long ZBRA,WORS2
        .long DUP,SPACE,DOTID
        .long CELLM
        .long BRAN,WORS1
        .long DROP
WORS2: .long EXIT







        __CODE,"place",PLACE
        movl (esp),ecx
        movzbl (ecx),edx
        movb dl,(ebx)
        movb $0,1(edx,ebx)
        incl ebx
        incl (esp)
        spush
        movl edx,ebx
        jmp CMOVE






        __COLON,"sh",SYSTEM
        .long DOLIT,CMD+3,PLACE,SHEL1
SHEL1:
        spush
        pushal
        xorl ebx,ebx
.if with_vfork
        sys_ vfork
.else
        sys_ fork
.endif
        testl eax,eax
        movl uCENVC(edi),edx
        movl $ARGS,ecx
        jnz 4f
        movl $SHT,ebx
        movl esp,ebp
        sys_ execve
4:
        writead ebx,eax
        js 5f
        movl eax,ebx
        xorl ecx,ecx
        xorl edx,edx
        sys_ waitpid
5:
        popal
        jmp EXIT



        __CODE,"ver",VERSN
        spush
        leal CELSZ(esi),esi
        movl $0x230034,ebx
        jmpl *(esi)



        __COLON,"hi",HI
        .long STOIO
        .long CR4,DOTQP
        .byte 1f-.-1
        .ascii "e4a v"
        .byte 2 +48
        .ascii "."
        .byte 3 +48
1:
        .align CELSZ,0
        .long CR4
        .long EXIT



        __VARI,"'boot",TBOOT
        .long STOIO



        __COLON,"cold",COLD
COLD1: .long DOLIT,UZERO,DOLIT,up2,AT
        .long DOLIT,ULAST-UZERO,CMOVE
COLD3: .long PRESET
        .long TBOOT,ATEXE
        .long FILE
        .long FILEQ,NZBRA,COLD2
        .long CONSOLE,HI
COLD2:
        .long FORTH,CNTXT,AT,DUP
        .long CRRNT,STOR2
        .long QUIT


        .data 0
CMD: resb 4096

LASTN = _NAME
NTOP = _NTOP

        .data 1

        .align CELSZ,0x90
CTOP = .
.end
